unit uCompDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PSDCipher, PSDMD5, StdCtrls, ExtCtrls, PSDDes, PSDBlowfish, PSDTwoFish,
  ComCtrls, Buttons;

type
  TfrmDemo = class(TForm)
    PSDTwoFish: TPSDTwoFish;
    PSDBlowFish: TPSDBlowFish;
    PSDDES: TPSDDES;
    OpenDialog: TOpenDialog;
    Label1: TLabel;
    edFile: TEdit;
    Label2: TLabel;
    edFileSize: TEdit;
    Label3: TLabel;
    RadioGroup: TRadioGroup;
    BtnEncrypt: TButton;
    BtnDecrypt: TButton;
    ProgressBar: TProgressBar;
    Label4: TLabel;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    PSDMD5: TPSDMD5;
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnEncryptClick(Sender: TObject);
    procedure PSDTwoFishProgress(nProgress: Byte; var lAbort: Boolean);
    procedure PSDBlowFishProgress(nProgress: Byte; var lAbort: Boolean);
    procedure PSDDESProgress(nProgress: Byte; var lAbort: Boolean);
    procedure BtnDecryptClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

implementation

{$R *.DFM}

procedure TfrmDemo.SpeedButton1Click(Sender: TObject);
Var SR: TSearchRec;
begin
  If OpenDialog.Execute Then Begin
    edFile.Text := OpenDialog.FileName;
    If FindFirst(edFile.Text, faAnyFile, SR) = 0 Then
      edFileSize.Text := IntToStr(SR.Size);
    FindClose(SR);
  End;
end;

procedure TfrmDemo.BtnEncryptClick(Sender: TObject);
Var Cipher : TCustomPSDCipher;
    nBlockSize : Byte;
    sCipherFile : String;
begin
  Case RadioGroup.ItemIndex Of
    0 : Begin
         Cipher := PSDBlowFish;
         nBlockSize := 8;
         sCipherFile := 'BLOWFISH.ENC';
        End;
    1 : Begin
         Cipher := PSDDES;
         nBlockSize := 8;
         sCipherFile := 'DES.ENC';
        End;
    2 : Begin
         Cipher := PSDTwoFish;
         nBlockSize := 16;
         sCipherFile := 'TWOFISH.ENC';
        End;
  Else
    Raise Exception.Create('No Cipher Method selected');
  End;

  With Cipher Do Begin
    BufferSize := (StrToInt(edFileSize.Text) div nBlockSize) div ProgressBar.Max;
    EncryptFile(edFile.Text, sCipherFile);
  End;
  ShowMessage('The file was encrypted correctly: ' + sCipherFile);
end;

procedure TfrmDemo.PSDTwoFishProgress(nProgress: Byte;
  var lAbort: Boolean);
begin
  ProgressBar.Position := nProgress;
  lAbort := False;
  Application.ProcessMessages;
end;

procedure TfrmDemo.PSDBlowFishProgress(nProgress: Byte;
  var lAbort: Boolean);
begin
  ProgressBar.Position := nProgress;
  lAbort := False;
  Application.ProcessMessages;
end;

procedure TfrmDemo.PSDDESProgress(nProgress: Byte; var lAbort: Boolean);
begin
  ProgressBar.Position := nProgress;
  lAbort := False;
  Application.ProcessMessages;
end;

procedure TfrmDemo.BtnDecryptClick(Sender: TObject);
Var Cipher : TCustomPSDCipher;
    nBlockSize : Byte;
    sPlainFile : String;
begin
  Case RadioGroup.ItemIndex Of
    0 : Begin
         Cipher := PSDBlowFish;
         nBlockSize := 8;
         sPlainFile := 'BLOWFISH.DEC';
        End;
    1 : Begin
         Cipher := PSDDES;
         nBlockSize := 8;
         sPlainFile := 'DES.DEC';
        End;
    2 : Begin
         Cipher := PSDTwoFish;
         nBlockSize := 16;
         sPlainFile := 'TWOFISH.DEC';
        End;
  Else
    Raise Exception.Create('No Cipher Method selected');
  End;

  With Cipher Do Begin
    BufferSize := (StrToInt(edFileSize.Text) div nBlockSize) div ProgressBar.Max;
    DecryptFile(edFile.Text, sPlainFile);
  End;
  ShowMessage('The file was decrypted correctly: ' + sPlainFile);
end;

procedure TfrmDemo.FormCreate(Sender: TObject);
begin
 // Key hashed using the MD5 hash function
  With PSDMD5 Do Begin
    PSDBlowFish.Key := EncryptString(PSDBlowFish.Key);
    PSDTwoFish.Key := EncryptString(PSDTwoFish.Key);
    PSDDES.Key := EncryptString(PSDDES.Key);
  End;
end;

end.
